/*
 * Copyright 2023 Peter <peter@quantr.hk>.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package hk.quantr.logic;

import com.formdev.flatlaf.intellijthemes.FlatArcOrangeIJTheme;
import hk.quantr.javalib.CommonLib;
import hk.quantr.javalib.swing.advancedswing.imageviewer.ImageViewerDialog;
import java.awt.Color;
import java.awt.Component;
import java.awt.Frame;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Base64;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.UIManager;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableCellRenderer;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONObject;

/**
 *
 * @author Peter <peter@quantr.hk>
 */
public class OpenFromQuantrDialog extends javax.swing.JDialog {
	
	MyTableModel model = new MyTableModel();
	MyTableRenderer renderer = new MyTableRenderer();
	public Data data;

	/**
	 * Creates new form OpenFromQuantrDialog
	 */
	public OpenFromQuantrDialog(java.awt.Frame parent, boolean modal) {
		super(parent, modal);
		initComponents();
		HttpGet post = new HttpGet("https://www.quantr.foundation/wp-content/plugins/quantr-foundation-wordpress-widgets/api/quantr-logic/getProjects.php");
		try (CloseableHttpClient httpClient = HttpClients.createDefault(); CloseableHttpResponse response = httpClient.execute(post)) {
			String result = EntityUtils.toString(response.getEntity());
			JSONArray arr = new JSONArray(result);
			for (int x = 0; x < arr.length(); x++) {
				JSONObject obj = arr.getJSONObject(x);
//				FileUtils.writeByteArrayToFile(new File("/Users/peter/Desktop/a.png"), Base64.getDecoder().decode(arr.getJSONObject(x).getString("image")));
				model.data.add(new Data(obj.getInt("id"), obj.getString("username"), obj.getString("projectName"), obj.getString("json"), Data.sdf.parse(obj.getString("createDate")), Base64.getDecoder().decode(arr.getJSONObject(x).getString("image"))));
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		} catch (ParseException ex) {
			ex.printStackTrace();
		}
		
		jTable1.setDefaultRenderer(Object.class, renderer);
		jTable1.setRowHeight(200);
		jTable1.getColumnModel().getColumn(4).setPreferredWidth(500);
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jTable1.setModel(model);
        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_LAST_COLUMN);
        jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTable1MouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(jTable1);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTable1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseClicked
		if (evt.getClickCount() == 2) {
			data = (Data) jTable1.getValueAt(jTable1.getSelectedRow(), 0);
			if (jTable1.getSelectedColumn() == 4) {
				try {
					InputStream is = new ByteArrayInputStream(data.image);
					BufferedImage b = ImageIO.read(is);
					ImageViewerDialog d = new ImageViewerDialog(null, true, b);
					d.setSize(1000, 800);
					d.setLocationRelativeTo(null);
					d.setVisible(true);
				} catch (IOException ex) {
					Logger.getLogger(OpenFromQuantrDialog.class.getName()).log(Level.SEVERE, null, ex);
				}
			} else {
				setVisible(false);
			}
		}
    }//GEN-LAST:event_jTable1MouseClicked

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		try {
			UIManager.setLookAndFeel(new FlatArcOrangeIJTheme());
		} catch (Exception ex) {
			System.err.println("Failed to initialize LaF");
		}

		/* Create and display the dialog */
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				OpenFromQuantrDialog dialog = new OpenFromQuantrDialog(new javax.swing.JFrame(), true);
				dialog.addWindowListener(new java.awt.event.WindowAdapter() {
					@Override
					public void windowClosing(java.awt.event.WindowEvent e) {
						System.exit(0);
					}
				});
				
				dialog.setSize(1400, 900);
				dialog.setLocationRelativeTo(null);
				dialog.setVisible(true);
			}
		});
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}

class Data {
	
	public int id;
	public String username;
	public String projectName;
	public byte image[];
	String json;
	Date createDate;
	public static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
	
	public Data(int id, String username, String projectName, String json, Date createDate, byte[] image) {
		this.id = id;
		this.username = username;
		this.projectName = projectName;
		this.json = json;
		this.createDate = createDate;
		this.image = image;
	}
	
}

class MyTableRenderer implements TableCellRenderer {
	
	JLabel label = new JLabel();
	
	public MyTableRenderer() {
		label.setOpaque(true);
	}
	
	@Override
	public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
		label.setText(null);
		label.setIcon(null);
		Data data = (Data) value;
		if (column == 0) {
			label.setText(String.valueOf(data.id));
		} else if (column == 1) {
			label.setText(data.username);
		} else if (column == 2) {
			label.setText(data.projectName);
		} else if (column == 3) {
			label.setText(Data.sdf.format(data.createDate));
		} else {
			try {
				InputStream is = new ByteArrayInputStream(data.image);
				BufferedImage b = ImageIO.read(is);
				label.setIcon(CommonLib.resizeImageByHeight(b, 200));
			} catch (IOException ex) {
				Logger.getLogger(MyTableRenderer.class.getName()).log(Level.SEVERE, null, ex);
			}
		}
		if (isSelected) {
			label.setBackground((Color) UIManager.get("Table.selectionBackground"));
			label.setForeground((Color) UIManager.get("Table.selectionForeground"));
		} else {
			label.setBackground((Color) UIManager.get("Table.background"));
			label.setForeground((Color) UIManager.get("Table.foreground"));
		}
		return label;
	}
}

class MyTableModel extends AbstractTableModel {
	
	public ArrayList<Data> data = new ArrayList();
	
	@Override
	public int getRowCount() {
		return data.size();
	}
	
	@Override
	public int getColumnCount() {
		return 5;
	}
	
	@Override
	public Object getValueAt(int rowIndex, int columnIndex) {
		return data.get(rowIndex);
	}
	
	@Override
	public Class<?> getColumnClass(int columnIndex) {
		return Object.class;
	}
	
	@Override
	public String getColumnName(int column) {
		if (column == 0) {
			return "ID";
		} else if (column == 1) {
			return "Username";
		} else if (column == 2) {
			return "Project Name";
		} else if (column == 3) {
			return "Date";
		} else {
			return "Image";
		}
	}
	
	@Override
	public boolean isCellEditable(int rowIndex, int columnIndex) {
		return false;
	}
	
	@Override
	public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
		
	}
}
